        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"

        xdef _main
        xdef _comment
        xdef _ti89


mask0 equ %11111110  ;(up\2nd\donw...)
mask1 equ %11111101  ;(Enter\clear...)
mask2 equ %11111011  ;( <- )
mask3 equ %11110111  ;(catalog...)
mask4 equ %11101111  ;(Mode...)
mask5 equ %11011111  ;(Home...)
mask6 equ %10111111  ;(ESC...)


        dc.l 'ICON'
        dc.w %0110110110110000
        dc.w %0100010101010000
        dc.w %0110110110110000
        dc.w %0000000000000000
        dc.w %0110110110110000
        dc.w %0101010100010000
        dc.w %0110110110110000
        dc.w %0000000000000000


_main
        tst.w quick
        beq normal

        bsr int_on
        clr.w quick
        bsr ini_screen
        bsr disp_board
        bsr disp_score
        bsr invert
        clr.w stop
        bra key_loop


normal

        jsr graphlib::clr_scr     ; on efface l'ecran

        SetFont #2
        WriteStr #53,#16,#4,title ;
        WriteStr #25,#50,#4,solo  ; on affiche le menu
        WriteStr #12,#70,#4,comp  ;
        move.w #10,d0
        move.w #10,d1
        move.w #140,d2
        move.w #20,d3
        clr.W d4
        jsr graphlib::fill


        pea.l notice(pc)
        jsr doorsos::ST_showHelp
        clr.w (a7)
        jsr doorsos::ST_busy
        lea 4(a7),a7

        move.w #50,pos            ; on initialise les variables
        bclr.b #0,mode

        bsr print

menu_loop
        jsr userlib::idle_loop
        cmp.w #264,d0
        beq exit
        cmp.W #340,d0             ; si bas alors on change de position
        beq autre
        cmp.w #337,d0
        beq autre
        cmp.W #13,d0
        beq start
        bra menu_loop

autre   bchg.b #0,mode
        bsr print
        cmp.w #50,pos
        beq \non
        move.w #50,pos
        bsr print
        bra menu_loop
\non    move.w #70,pos
        bsr print
        bra menu_loop

print   move.w pos,d1
        sub.w #1,d1
        move.w #10,d0
        move.w #140,d2
        move.w #10,d3
        clr.w d4
        jsr graphlib::fill
        rts




start   bsr int_on                 

restart bsr ini_screen             ; on affiche l'ecran
        bsr ini_board              ; on met en place les boules

        clr.b player               ; player 1 joue en premier
        bsr disp_board             ; affiche les boules et celui qui doit joue
        bsr disp_score             ; affiche les scores
        move.w #11,pos             ; initialise la position du curseur
        bsr invert                 ; on inverse la case ou il est
        clr.w stop
key_loop:
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq check_key_esc

        tst.w stop
        beq \apres
        sub.w #1,stop
        bra key_loop

\apres  clr.w d1
        move.w #mask0,d0
        bsr get_key
        btst.b #0,d0
        beq update_pos
        add.w #2,d1
        btst.b #3,d0
        beq update_pos
        add.w #2,d1
        btst.b #2,d0
        beq update_pos
        add.w #2,d1
        btst.b #1,d0
        beq update_pos
        btst.b #4,d0
        beq select
        move.w #mask1,d0
        bsr get_key
        btst.b #1,d0
        beq inc_speed
        btst.b #2,d0
        beq dec_speed
        btst.b #6,d0
        beq restart
        move.w #mask5,d0
        bsr get_key
        btst.b #6,d0
        beq quick_exit
        bra key_loop


update_pos:                     ; update la position du curseur
        move.l #board,a0
        move.l #table,a1
        add.w d1,a1
        move.w (a1),d7
        move.w pos,d0
        add.w d7,d0                
        cmp.b #3,0(a0,d0.w)
        beq key_loop
        bsr invert
        add.w d7,pos
        bsr invert
        move.w speed,stop
        bra key_loop

dec_speed:                      ; fait la gestion de la vitess
        add.w #1,speed
rvient  move.w #15,stop
        bra key_loop
inc_speed:
        sub.w #1,speed
        bne rvient
        add.w #1,speed
        bra rvient


select  clr.w d0
        move.b player,d0
        lea.l player_table(pc),a0
        lsl.w #1,d0
        add.w d0,a0
        move.b (a0)+,player1
        move.b (a0),player2
        bsr copy_board
        bsr solve
        tst.w d6                        ; si on peut rien faire alors on revient
        beq key_loop
        bsr copy_save                   ; sinon on prend en compte
        bchg.b #0,player                ; on change de joueur
\passe  bsr invert                      
        bsr disp_board                  ; on reaffiche le terrain
        bsr invert                      ; avec le nouveau score
        bsr disp_score                  ;
        add.w d3,d4
        cmp.W #64,d4                    ; si la somme des scores vaut
        beq fin                         ; 64 alors c'est fini
        bsr check_end
        tst.w d0
        beq fin
        btst.b #0,mode                  ; son verifie le mode
        beq key_loop
        tst.b player                    ; ici c'est au tout de l'ordinateur
        bne computer                    ; de jouer
        bra key_loop

fin:    bsr int_off
        bsr disp_score
        cmp.w d3,d4
        blt p1_win
        bgt p2_win
        WriteStr #110,#3,#1,draw_str
        WriteStr #110,#85,#1,draw_str
wait    SetFont #0
        WriteStr #10,#95,#4,help
        jsr userlib::idle_loop
        cmp.w #264,d0
        beq _main
        cmp.w #13,d0
        beq start
        bra wait

        
p1_win  WriteStr #96,#3,#1,you_win_str
        WriteStr #96,#85,#1,you_lose_str
        bra wait

p2_win  WriteStr #96,#85,#1,you_win_str
        WriteStr #96,#3,#1,you_lose_str
        bra wait


computer:
        bsr invert
        move.b #1,player2
        move.b #2,player1
        clr.w pos
        move.w #99,stop
        clr.w data
\loop   bsr copy_board
        bsr solve
        cmp.w data,d6
        ble \apres
        move.w d6,data
        move.w pos,data2
\apres  add.w #1,pos
        sub.w #1,stop
        bne \loop
        move.w data2,pos
        bsr invert
        bra select


disp_score
        move.l #board,a0           ; affiche les scrores
        moveq #99,d0
        clr.w d3
        clr.w d4
loopc   move.b (a0)+,d1
        cmp.b #1,d1
        beq inc_p1
        cmp.B #2,d1
        beq inc_p2
skip    dbra d0,loopc
        SetFont #2
        move.w d3,d0
        bsr print_value
        WriteStrA #120,#17,#4,a0
        move.w d4,d0
        bsr print_value
        WriteStrA #120,#73,#4,a0
        rts
inc_p1  add.w #1,d3
        bra skip
inc_p2  add.w #1,d4
        bra skip


solve:  clr.w d6             ; dis le nombre de coup possible dans d6
        move.l #save,a0
        add.w pos,a0
        tst.b (a0)
        bne exit
        move.l a0,cur
        move.l #table,a1        
        move.w #7,d5
        move.b player1,d2
        move.b player2,d1
check   move.w (a1)+,d0
        clr.w d7
        move.l cur,a0
loop    add.w #1,d7
        add.w d0,a0
        cmp.b (a0),d1
        beq loop
        cmp.b (a0),d2
        bne loop3
        sub.w #1,d7
        tst.w d7
        beq loop3
loop2   sub.w d0,a0
        move.b d2,(a0)
        add.w #1,d6
        dbra d7,loop2
        sub.W #1,d6
loop3   dbra d5,check
        rts


check_end
        move.w pos,data2
        clr.w pos
        move.w #100,data
\loop   bsr copy_board    ; on copy l'ecran
        bsr solve
        tst.w d6
        bne bon
        add.w #1,pos
        sub.w #1,data
        bne \loop
        move.w data2,pos
        clr.w d0
        rts
bon     move.w data2,pos
        move.w #1,d0
        rts



disp_board
        move.l #board+11,a6             ; affiche le terrain
        clr.l d5
        moveq #1,d0
        moveq #1,d1
        moveq #7,d6
\loop1  moveq #7,d7
\loop2  move.b (a6)+,d5
        mulu #24,d5
        move.l #sprite,a0
        add.w d5,a0
        move.b #$FF,d3
        jsr graphlib::put_sprite_mask
        add.w #12,d0
        dbra d7,\loop2
        lea 2(a6),a6
        moveq #1,d0
        add.w #12,d1
        dbra d6,\loop1
        moveq #0,d0
        moveq #8,d7
        moveq #1,d1
        moveq #96,d2
\loopv  jsr graphlib::vert
        add.w #12,d0
        dbra d7,\loopv
        moveq #0,d0
        moveq #8,d7
        moveq #0,d1
        moveq #95,d2
        moveq #2,d3
\looph  jsr graphlib::horiz
        add.w #12,d1
        dbra d7,\looph
        move.l #sprite,a0
        move.b #$FF,d3
        move.w #105,d0
        clr.w d1
        move.b player,d1
        bchg.b #0,d1
        mulu #56,d1
        add.w #16,d1
        jsr graphlib::put_sprite_mask
        clr.l d0
        move.b player,d0
        move.l #sprite+24,a0
        mulu #24,d0
        add.w d0,a0
        move.w #105,d0
        clr.w d1
        move.b player,d1
        mulu #56,d1
        add.w #16,d1
        move.b #$FF,d3
        jsr graphlib::put_sprite_mask
        rts


invert  movem.l a0-a6/d0-d7,-(a7)     ; inverse le curseur et le modifie
        clr.l d0                      ; si on peut jouer (carre a l'interieur)
        clr.l d1
        move.w pos,d0
        divu #10,d0
        move.w d0,d1
        swap d0
        mulu #12,d0
        sub.w #11,d0
        mulu #12,d1
        sub.w #11,d1
        moveq #10,d2
        moveq #10,d3
        clr.w d4
        jsr graphlib::fill
        move.b player,d0
        lea.l player_table(pc),a0
        lsl.w #1,d0
        add.w d0,a0
        move.b (a0)+,player1
        move.b (a0),player2
        bsr copy_board
        bsr solve
        tst.w d6
        beq fini
        move.w pos,d0
        divu #10,d0
        move.w d0,d1
        swap d0
        mulu #12,d0
        sub.w #7,d0
        mulu #12,d1
        sub.w #7,d1
        moveq #2,d2
        moveq #2,d3
        clr.w d4
        jsr graphlib::fill
fini    movem.l (a7)+,a0-a6/d0-d7
        rts


copy_board:
        move.l #board,a0
        move.l #save,a1
do_it   moveq #99,d0
\loop   move.b (a0)+,(a1)+
        dbra d0,\loop
        rts
copy_save:
        move.l #board,a1
        move.l #save,a0
        bra do_it


ini_board:                   ; initialise le terrain
        move.l #board,a0
        moveq #99,d0
loopi   add.l #1,a0
        cmp.b #3,(a0)
        beq \saute
        clr.b (a0)
\saute  dbra d0,loopi
        move.l #board+10*4+4,a0
        move.B #1,(a0)
        move.B #2,1(a0)
        move.b #1,11(a0)
        move.B #2,10(a0)
        rts

ini_screen:                     ; initialise l'ecran
        jsr graphlib::clr_scr
        clr.w d0
        clr.w d1
        move.w #159,d4
        move.w #96,d5
        jsr graphlib::frame
        SetFont #1
        WriteStr #112,#37,#4,human
        tst.B mode
        bne \autre
        WriteStr #112,#53,#4,human
        bra \apres
\autre  WriteStr #103,#53,#4,computer_str
\apres  moveq #96,d0
        moveq #48,d1
        move.w #158,d2
        clr.w d3
        jsr graphlib::horiz
        rts



print_value:
        move.l #str+8,a0
        clr.b (a0)
print_loop:
        divu #10,d0
        swap d0
        add.b #48,d0
        move.b d0,-(a0)
        swap d0
        divu #10,d0
        add.b #48,d0
        move.b d0,-(a0)
        rts

int_on  clr.l d0
        move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l ($64),old_int
        move.l #new_int,($64)
        bset.b #2,($600001)
        trap #1
	rts
int_off clr.l d0
        move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l old_int,($64)
        bset.b #2,($600001)
        trap #1
	rts
new_int rte

get_key move.w  d0,$600018
        move.w #50,d0
delay_c dbra d0,delay_c
        move.b $60001b,d0
exit    rts

check_key_esc
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne key_loop
\wait   move.w #mask6,d0
        bsr get_key
        btst.B #0,d0
        beq \wait
        bsr int_off
        bra _main

quick_exit
        move.w #1,quick
        bra int_off

sprite:
        dc.w 10
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 10
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000111000000000
        dc.w %0001000100000000
        dc.w %0010000010000000
        dc.w %0100000001000000
        dc.w %0100000001000000
        dc.w %0100000001000000
        dc.w %0010000010000000
        dc.w %0001000100000000
        dc.w %0000111000000000

        dc.w 10
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000111000000000
        dc.w %0001111100000000
        dc.w %0011111110000000
        dc.w %0111111111000000
        dc.w %0111111111000000
        dc.w %0111111111000000
        dc.w %0011111110000000
        dc.w %0001111100000000
        dc.w %0000111000000000






board   dc.b 3,3,3,3,3,3,3,3,3,3
        dc.b 3,1,1,2,2,1,1,1,1,3
        dc.b 3,0,1,1,2,2,1,1,1,3
        dc.b 3,1,2,1,2,1,1,1,1,3
        dc.b 3,1,1,2,1,2,1,1,1,3
        dc.b 3,1,1,1,1,1,1,1,1,3
        dc.b 3,2,1,1,1,1,1,1,1,3
        dc.b 3,2,1,1,1,1,1,1,1,3
        dc.b 3,2,1,1,1,1,1,1,1,3
        dc.b 3,3,3,3,3,3,3,3,3,3

        
pos dc.w 0
cur dc.l 0
str ds.b 9
player1 dc.b 0
player2 dc.b 0
player  dc.b 0
stop    dc.w 0
speed   dc.w 1000
quick   dc.w 0

table dc.w -10,1,10,-1,-11,-9,9,11

player_table dc.b 1,2,2,1

title dc.b "OTHELLO",0
solo  dc.b "HUMAN VS HUMAN",0
comp  dc.b "HUMAN VS COMPUTER",0
human dc.b "HUMAN",0
computer_str dc.b "COMPUTER",0
you_win_str  dc.b "You win!",0
you_lose_str dc.b "You lose",0
draw_str     dc.b "Draw",0
help         dc.b "press [ENTER] or [ESC]",0
notice       dc.b "Othello v1.0 by Endive: press [ENTER]",0

mode  dc.b 0

_comment dc.b "Othello by Endive",0

 BSS

save    ds.b 10*10
old_int ds.l 1
data    ds.w 1
data2   ds.w 1

 end
